/*
 * Bot Utils
 *
 * $Author: flan $
 * $Date: 1994/03/01 06:54:53 $
 *
 * $Log: botutils.c,v $
 * Revision 2.0  1994/03/01  06:54:53  flan
 * Autospam First Release
 *
 * Revision 1.2  1993/11/24  10:44:06  flan
 * -First Stupid Release
 *
 * Revision 1.2  1993/11/24  10:44:06  flan
 * Reformatted some stuff.  No major mods.
 *
 * Revision 1.1  1993/11/23  10:25:22  flan
 * Added GetPlayerFromMessage( char *message ).
 *
 */

/* 	$Id: botutils.c,v 2.0 1994/03/01 06:54:53 flan Rel $	 */

#ifndef lint
static char vcid[] = "$Id: botutils.c,v 2.0 1994/03/01 06:54:53 flan Rel $";
#endif /* lint */

#include <stdio.h>
#include <math.h>
#include "config.h"
#include "copyright.h"

#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#include "bot.h"

int	updateDelay = 1;

getglobalcourse(x, y)
     int x, y;
{
    return((unsigned char) (atan2((double) (x - me->p_x),
        (double) (me->p_y - y)) / 3.14159 * 128.));
}

struct planet *closest_planet(p)
struct player *p;
{
  register struct planet *pl,*res;
  register int i;
  register long mindist,dx,dy,dist;
  
  if(p->p_x < 0) return(NULL);
  pl = &planets[0];
  dx = (p->p_x - pl->pl_x) / 100;
  dy = (p->p_y - pl->pl_y) / 100;
  mindist = dx*dx + dy*dy;
  res = pl;
  for(i = 1, pl = &planets[i]; i < MAXPLANETS; i++, pl++) {
    dx = (p->p_x - pl->pl_x) / 100;
    dy = (p->p_y - pl->pl_y) / 100;
    dist = dx*dx + dy*dy;
    if(dist < mindist) {
      mindist = dist;
      res = pl;
    }
  }
  return(res);
}

unsigned char vector_speed_course(mx, my, ndir, vdir, dx, dy, ax, esp)
     int esp;
     double mx, my, dx, dy, ax;
     unsigned char ndir, vdir;
{
  register unsigned char dir = 0, bestdir = 0;
  register double bestdiff = 1.0e+20, diff = 0.0, spd, dsqr;
  register int sign, basespeed;
  
  if((ndir == vdir) || (me->p_speed == 0) || (esp == 0)) return(ndir);
  if(ndir > vdir) {
    if(ndir - vdir > 128) {
      sign = 1;
    } else {
      sign = -1;
    }
  } else {
    if(vdir - ndir > 128) {
      sign = -1;
    } else {
      sign = 1;
    }
  }
  dsqr = dx*dx + dy*dy;
  basespeed = me->p_ship.s_torpspeed * WARP1;
  for(dir = ndir; dir != vdir; dir += sign) {
    spd = (((double) basespeed)*Cos[dir] + mx)
      * (((double) basespeed)*Cos[dir] + mx)
	+ (((double) basespeed)*Sin[dir] + my)
	  * (((double) basespeed)*Sin[dir] + my);
    if(spd > ((double) (400*WARP1*WARP1))) spd = (double) (400*WARP1*WARP1);
    diff = sqrt(spd - dsqr) * ax + dx - sqrt(spd)*Cos[dir];
    
    if(diff < 0.0) diff *= -1.0;
    if(diff < bestdiff) {
      bestdiff = diff;
      bestdir = dir;
    }
  }
  return(bestdir);
}

struct Enemy ebuf;

struct Enemy *get_nearest(targ)
int targ;
{
  int pcount = 0;
  register int i;
  register struct player *j;
  int tdist;
  double dx, dy;
  
  /* Find an enemy */
  ebuf.e_flags = 0;
  ebuf.e_info = me->p_no;
  ebuf.e_dist = GWIDTH + 1;
  
  pcount = 0;  /* number of human players in game */
  
  /* avoid dead slots, me */
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if ((j->p_status != PALIVE) || (j == me))
	continue;
      else
	pcount++;   /* Other players in the game */
      if (((j->p_swar | j->p_hostile) & me->p_team)
	  || ((me->p_swar | me->p_hostile) & j->p_team))
	{
	  /* We have an enemy */
	  /* Get his range */
	  dx = j->p_x - me->p_x;
	  dy = j->p_y - me->p_y;
	  tdist = hypot(dx, dy);
	  
	  if (tdist < ebuf.e_dist)
	    {
	      ebuf.e_info = i;
	      ebuf.e_dist = tdist;
	    }
	  if(targ && (j->p_no == borgTarget))
	    {
	      if(firing_solution(j))
		return(&ebuf);
	    }
    	}
    }
  if (pcount == 0)
    {
      return (NOENEMY);    /* no players in game */
    }
  else if (ebuf.e_info == me->p_no)
    {
      return (0);         /* no hostile players in the game */
    }
  else
    {
      j = &players[ebuf.e_info];
      firing_solution(j);
      return (&ebuf);
    }
}

int firing_solution(j)
struct player	*j;
{
  double dx, dy;
  double vxa, vya, l; /* Used for trap shooting */
  double vxt, vyt;
  double vxs, vys;
  double vxm, vym;
  double dp,comp;
  unsigned char ndir,vdir,fdir;
	/* Get torpedo course to nearest enemy */

  vxa = (j->p_x - me->p_x);
  vya = (j->p_y - me->p_y);
  l = hypot(vxa, vya);    /* Normalize va */
  if (l != 0)
    {
      vxa /= l;
      vya /= l;
    }
  vxs = updateDelay * (Cos[j->p_dir] * j->p_speed) * WARP1;
  vys = updateDelay * (Sin[j->p_dir] * j->p_speed) * WARP1;
  dp = vxs * vxa + vys * vya;	/* Dot product of (va vs) */
  dx = vxs - dp * vxa;
  dy = vys - dp * vya;
  l = hypot(dx, dy);      /* Determine how much speed is required */
  dp = (float) (me->p_ship.s_torpspeed * WARP1);
  l = (dp * dp - l * l);
  if (l > 0)
    {
      double he_x, he_y, area;
      
      /* Only shoot if within distance */
      he_x = j->p_x + Cos[j->p_dir] * j->p_speed * 50 * WARP1;
      he_y = j->p_y + Sin[j->p_dir] * j->p_speed * 50 * WARP1;
      area = 50 * me->p_ship.s_torpspeed * WARP1;
      if (hypot(he_x - me->p_x, he_y - me->p_y) < area)
	{
	  l=sqrt(l);
	  vxt = l * vxa + dx;
	  vyt = l * vya + dy;
	  if(torpFlightType == 1)
	    {
	      vxm = (Cos[me->p_dir] * me->p_speed) * WARP1;
	      vym = (Sin[me->p_dir] * me->p_speed) * WARP1;
	      vxt -= vxm;
	      vyt -= vym;
	    }
	  if(torpFlightType == 2)
	    {
	      vxm = (Cos[me->p_dir] * me->p_speed) * WARP1;
	      vym = (Sin[me->p_dir] * me->p_speed) * WARP1;
	      
	      ndir = getglobalcourse((int) vxt + me->p_x,
				     (int) vyt + me->p_y);
	      vxt -= vxm;
	      vyt -= vym;
	      vdir = getglobalcourse((int) vxt + me->p_x,
				     (int) vyt + me->p_y);
	      fdir = vector_speed_course(vxm, vym, ndir, vdir, dx,
					 dy, vxa, j->p_speed);
	    }
	  ebuf.e_flags |= E_TSHOT;
	  if(torpFlightType == 2)
	    {
	      ebuf.e_tcourse = fdir;
	    }
	  else
	    {
	      if(((int) vxt == 0) && ((int) vyt == 0))
		{
		  ebuf.e_flags &= ~(E_TSHOT);
		}
	      else
		{
		  ebuf.e_tcourse =
		    getglobalcourse((int) vxt + me->p_x, (int) vyt + me->p_y);
		}
	    }
	}
    }
  
  /* Get phaser shot status */
  if (ebuf.e_dist < PHASEDIST * me->p_ship.s_phaserdamage / 100)
    ebuf.e_flags |= E_PSHOT;
  else
    ebuf.e_flags &= ~(E_PSHOT);

  /* get course info */
  if((j->p_x == me->p_x) && (j->p_y == me->p_y))
    {
      ebuf.e_flags &= ~(E_PSHOT);
    }
  else
    {
      ebuf.e_course =
	getglobalcourse(j->p_x
			+ (int) ((Cos[j->p_dir] * (double) j->p_speed) * WARP1)
			* updateDelay,
			j->p_y
			+ (int) ((Sin[j->p_dir] * (double) j->p_speed) * WARP1)
			* updateDelay);
    }
  /*
     if (debug)
     fprintf(stderr, "Set course to enemy is %d (%d)\n",
     (int) ebuf.e_course,
     (int) ebuf.e_course * 360 / 256);
   */
  if(ebuf.e_flags == 0)
    return(0);
  else
    return(1);
}

int
GetPlanetByName( char *name )
{
  int i, l;
  
  l = (strlen(name) < 16) ? strlen(name) : 16;
  
  for (i = 0; i < MAXPLANETS; i++)
    {
      if (strncmp(name, planets[i].pl_name, l) == 0)
	return i;
    }
  
  return -1;
}

int
GetPlayerByName( char *name )
{
  int i, l;
  
  l = strlen(name) < 16 ? strlen(name) : 16;
  
  for (i = 0; i < MAXPLAYER; i++)
    {
/*      printf("Player[%i]: -%s- <%i>\n",
	     i, players[i].p_name, strlen(players[i].p_name));
*/    if ((players[i].p_status != PFREE)
	  && (strncmp(name, players[i].p_name, l) == 0))
	return i;
    }
  
  return -1;
}


int
PlayerNearestPlayer( int player )
{
  int i;
  double dist = hypot((double)GWIDTH, (double)GWIDTH), h;
  double dx, dy;
  int nearest = player;
  
  for (i = 0; i < MAXPLAYER; i++)
    {
      if (i == player)
	continue;
      dx = players[i].p_x - players[player].p_x;
      dy = players[i].p_y - players[player].p_y;
      h = hypot( dx, dy);
      if (h < dist)
	{
	  dist = h;
	  nearest = i;
	}
    }

  return nearest;
}


int
GetPlayerFromMessage( char *message )
{
  char team = message[0];
  char player = message[1];

  switch (team)
    {
    case 'F':
    case 'R':
    case 'O':
    case 'K':
      break;
    default:
      return -1;
    }
  
  if ((player >= '0') && (player <= '9'))
    {
      return player - '0';
    }
  
  if ((player >= 'a') && (player <= ('a' + MAXPLAYER)))
    {
      return player - 'a' + 10;
    }
  
  return -1;
}
