
/*
 * redraw.c
 */
#include "config.h"
#include "copyright.h"

#include <stdio.h>
#include <signal.h>
#include <math.h>
#include <time.h>
#include INC_SYS_TIME
#include <sys/types.h>
#include <sys/socket.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#ifdef SOUND
static int p_sound = 0;
static int sound_torps = 0;
static unsigned int sound_flags = 0;
static int explode_sound = 0;
#endif

#define NORMALIZE(d) (((d) + 256) % 256)

static int clearzone[4][(MAXTORP + 1) * MAXPLAYER +
			  (MAXPLASMA + 1) * MAXPLAYER + MAXPLANETS];
static int clearcount;
#ifdef HOCKEY_LINES
static int clearline[4][MAXPLAYER + 2 * MAXPLAYER + NUM_HOCKEY_LINES];
#else
static int clearline[4][MAXPLAYER + 2 * MAXPLAYER];
#endif
static int clearlmark[4];
static int clearlmcount;
static int clearlcount;

static int mclearzone[6][MAXPLAYER];	/* For map window */

static short nplayers;

static int last_newPlist;
static int last_sortPlayers;
static unsigned short milli_time = 0;

static time_t lastread;

#ifdef BRMH
intrupt (readfds)
     fd_set *readfds;
#else
intrupt ()
#endif
{
  time_t time ();

  udcounter++;
#ifdef BRMH
  if (readFromServer (readfds))
#else
  if (readFromServer ())
#endif
    {
      lastread = time (NULL);
      redraw ();

      updateMaxStats (0); 	/* Update the max stats <isae> */

      if ((newPlist == last_newPlist) && (sortPlayers == last_sortPlayers))
	playerlist2 ();
      else
	{
	  playerlist ();
	  last_newPlist = newPlist;
	  last_sortPlayers = sortPlayers;
	}
    }

  if (reinitPlanets)
    {
      initPlanets ();
      reinitPlanets = 0;
    }

  if (me->p_status == POUTFIT)
    {
      death ();
    }
}

redraw ()
{
  /* erase warning line if necessary */
  if ((warntimer <= udcounter) && (warncount > 0))
    {
      /* XFIX */
      W_ClearArea (warnw, 5, 5, W_Textwidth * warncount, W_Textheight);
      warncount = 0;
    }

  run_clock (lastread);		/* for hosers who don't know what a Xclock is */
  if (W_FastClear)
    {
      W_ClearWindow (w);
      clearcount = 0;
      clearlcount = 0;
    }
  else
    {
      while (clearcount)
	{
	  clearcount--;
	  /* XFIX */
	  W_CacheClearArea (w, clearzone[0][clearcount],
			 clearzone[1][clearcount], clearzone[2][clearcount],
			    clearzone[3][clearcount]);

	  /*
	     W_ClearArea(w, clearzone[0][clearcount], clearzone[1][clearcount],
	     clearzone[2][clearcount], clearzone[3][clearcount]);
	   */
	}
      while (clearlcount)
	{
	  clearlcount--;
	  /* XFIX */
	  W_CacheLine (w, clearline[0][clearlcount], clearline[1][clearlcount],
		       clearline[2][clearlcount], clearline[3][clearlcount],
		       backColor);
	  /*
	     W_MakeLine(w, clearline[0][clearlcount], clearline[1][clearlcount],
	     clearline[2][clearlcount], clearline[3][clearlcount],
	     backColor);
	   */
	}
      /* XFIX */
      W_FlushClearAreaCache (w);
      W_FlushLineCaches (w);
    }

  local ();			/* redraw local window */

  /* XFIX */
  W_FlushLineCaches (w);

  if (newDashboard)		/* 6/2/93 LAB */
    if (newDashboard == old_db)
      db_redraw (0);
    else
      redrawTstats ();
  else if (newDashboard == old_db)
    stline (0);
  else
    redrawTstats ();

  old_db = newDashboard;

  if (W_IsMapped (statwin))
    updateStats ();

  /* XFIX: last since its least accurate information */
  if (mapmode)
    map ();
}

W_Icon
planetBitmap (p)
     register struct planet *p;
{
  int i;

  if (showlocal == 2)
    {
      return (bplanets[0]);
    }
  else if (p->pl_info & me->p_team)
    {
      if (showlocal == 1)
	{
	  i = 0;
	  if (p->pl_armies > 4)
	    i += 4;
	  if (p->pl_flags & PLREPAIR)
	    i += 2;
	  if (p->pl_flags & PLFUEL)
	    i += 1;
	  return (bplanets2[i]);
	}
      else
	{
	  return (bplanets[remap[p->pl_owner]]);
	}
    }
  else
    {
      return (noinfoplanet);
    }
}


W_Icon
planetmBitmap (p)
     register struct planet *p;
{
  int i;

  if (showgalactic == 2)
    {
      return (mbplanets[0]);
    }
  else if (p->pl_info & me->p_team)
    {
      if (showgalactic == 1)
	{
	  i = 0;
	  if (p->pl_armies > 4)
	    i += 4;
	  if (p->pl_flags & PLREPAIR)
	    i += 2;
	  if (p->pl_flags & PLFUEL)
	    i += 1;
	  if (myPlanetBitmap == 1)
	    return (mbplanets3[i]);	/* <isae> new bitmaps */
#ifdef RABBIT_EARS
	  else if (myPlanetBitmap == 2)
	    return (mbplanets4[i]);
#endif
	  else
	    return (mbplanets2[i]);
	}
      else
	{
	  return (mbplanets[remap[p->pl_owner]]);
	}
    }
  else
    {
      return (mbplanets[5]);
    }
}

/* draw out the 'tactical' map */
local ()
{
  register int h, i;
  register struct player *j;
  register struct torp *k;
  register struct planet *l;
  register struct phaser *php;
  register struct plasmatorp *pt;

#ifdef HOCKEY_LINES
  register int my_x = me->p_x, my_y = me->p_y;
  register struct s_line *sl;
  static int      HALF_WINSIDE = WINSIDE / 2;
  static int      GPWIDTH = GWIDTH / SCALE;
  int             my_px = my_x / SCALE;
  int             my_py = my_y / SCALE;
  int             ex, ey, sx, sy;
#endif


  int dx, dy, px, py, wx, wy;
  int view;
  char idbuf[10];
#ifndef DYNAMIC_BITMAPS
  W_Icon (*ship_bits)[VIEWS];
#endif

  if (me->p_x < 0)
    return;

  /* Kludge to try to fix missing ID chars on tactical (short range) display. */
  idbuf[0] = '0';
  idbuf[1] = '\0';
  /* Draw Planets */
  view = SCALE * WINSIDE / 2;
  for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++)
    {
      dx = l->pl_x - me->p_x;
      dy = l->pl_y - me->p_y;
      if (dx > view || dx < -view || dy > view || dy < -view)
	continue;
      dx = dx / SCALE + WINSIDE / 2;
      dy = dy / SCALE + WINSIDE / 2;
      /* if using 'moo' bitmaps, and showing owner/nothing on local map,
         use moo bitmap too! */
      if (myPlanetBitmap && (showlocal == 0 || showlocal == 2)
	  && l->pl_info & me->p_team)
	{
	  int bitmi = 0;
	  if (l->pl_armies > 4)
	    bitmi += 4;
	  if (l->pl_flags & PLREPAIR)
	    bitmi += 2;
	  if (l->pl_flags & PLFUEL)
	    bitmi += 1;

#ifdef RABBIT_EARS
	  if (myPlanetBitmap == 1)
	    W_WriteBitmap (dx - (planet_width / 2), dy - (planet_height / 2), bplanets3[bitmi], planetColor (l));
	  else
	    W_WriteBitmap (dx - (planet_width / 2), dy - (planet_height / 2), bplanets4[bitmi], planetColor (l));
#else
	  W_WriteBitmap (dx - (planet_width / 2), dy - (planet_height / 2), bplanets3[bitmi], planetColor (l));
#endif
	}
      else
	{
	  W_WriteBitmap (dx - (planet_width / 2), dy - (planet_height / 2),
			 planetBitmap (l), planetColor (l));
	}
      if (showIND && (l->pl_info & me->p_team) && (l->pl_owner == NOBODY))
	{
	  W_CacheLine (w, dx - (planet_width / 2), dy - (planet_height / 2),
		  dx + (planet_width / 2 - 1), dy + (planet_height / 2 - 1),
		       W_White);
	  W_CacheLine (w, dx + (planet_width / 2 - 1), dy - (planet_height / 2),
		       dx - (planet_width / 2), dy + (planet_height / 2 - 1),
		       W_White);
	}
      if (namemode)
	{
	  W_MaskText (w, dx - (planet_width / 2), dy + (planet_height / 2),
		      planetColor (l), l->pl_name, l->pl_namelen,
		      planetFont (l));
	  clearzone[0][clearcount] = dx - (planet_width / 2);
	  clearzone[1][clearcount] = dy + (planet_height / 2);
	  clearzone[2][clearcount] = W_Textwidth * l->pl_namelen;
	  clearzone[3][clearcount] = W_Textheight;
	  clearcount++;
	}
      clearzone[0][clearcount] = dx - (planet_width / 2);
      clearzone[1][clearcount] = dy - (planet_height / 2);
      clearzone[2][clearcount] = planet_width;
      clearzone[3][clearcount] = planet_height;
      clearcount++;
    }

  /* Draw ships */
  nplayers = 0;
  view = SCALE * WINSIDE / 2;
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      int tx, ty;

      if ((j->p_status != PALIVE) && (j->p_status != PEXPLODE))
	continue;
      nplayers++;
      /* observer and NOT locked onto a player (ie. locked onto planet or
         vacuum */
      if ((j->p_flags & PFOBSERV) && !(j->p_flags & PFPLOCK))
	continue;

      /* observer and NOT cloaked - don't display ship but do tractors
         phasers and torps are done for that ship already */
      if ((j->p_flags & PFOBSERV) && !(j->p_flags & PFCLOAK))
	continue;
      /* jmn - observer support.. tried to diplay tractors but no works */

      if (j->p_flags & PFCLOAK)
	{
	  if (j->p_cloakphase < (CLOAK_PHASES - 1))
	    {
#ifdef SOUND
	      if (myPlayer (j) && (j->p_cloakphase == 0))
		Play_Sound (CLOAK_SOUND);
#endif
	      j->p_cloakphase++;
	    }
	}
      else
	{
	  if (j->p_cloakphase)
	    {
	      j->p_cloakphase--;
	    }
#ifdef SOUND
	  if (j->p_cloakphase > 0)
	    Abort_Sound (CLOAK_SOUND);
#endif
	}
      dx = j->p_x - me->p_x;
      dy = j->p_y - me->p_y;
      if (dx > view || dx < -view || dy > view || dy < -view)
	continue;
      dx = dx / SCALE + WINSIDE / 2;
      dy = dy / SCALE + WINSIDE / 2;

      if (j->p_flags & PFCLOAK && (j->p_cloakphase == (CLOAK_PHASES - 1)))
	{
	  if (myPlayer (j))
	    {
	      W_WriteBitmap (dx - (cloak_width / 2), dy - (cloak_height / 2),
			     cloakicon, myColor);
#ifdef VARY_HULL
	      clearzone[0][clearcount] = dx - (shield_width / 2 + 1);
	      clearzone[1][clearcount] = dy - (shield_height / 2 + 1);
	      clearzone[2][clearcount] = shield_width + 3;
	      clearzone[3][clearcount] = shield_height + 3;
	      clearcount++;
#else
	      clearzone[0][clearcount] = dx - (shield_width / 2);
	      clearzone[1][clearcount] = dy - (shield_height / 2);
	      clearzone[2][clearcount] = shield_width;
	      clearzone[3][clearcount] = shield_height;
	      clearcount++;
#endif
	      goto shieldlabel;	/* draw the shield even when cloaked */
	    }
	  continue;
	}
      if (j->p_status == PALIVE)
	{
#ifndef DYNAMIC_BITMAPS
	  switch (j->p_team)
	    {
	    case FED:
#ifdef TNG_FED_BITMAPS
	      if (use_tng_fed_bitmaps)
		ship_bits = tng_fed_bitmaps;
	      else
		ship_bits = fed_bitmaps;
#else
	      ship_bits = fed_bitmaps;
#endif
	      break;
	    case ROM:
	      ship_bits = rom_bitmaps;
	      break;
	    case KLI:
	      ship_bits = kli_bitmaps;
	      break;
	    case ORI:
	      ship_bits = ori_bitmaps;
	      break;
	    default:
	      ship_bits = ind_bitmaps;
	      break;
	    }
#endif

#ifdef VARY_HULL
	  clearzone[0][clearcount] = dx - (shield_width / 2 + 1);
	  clearzone[1][clearcount] = dy - (shield_height / 2 + 1);
	  clearzone[2][clearcount] = shield_width + 3;
	  clearzone[3][clearcount] = shield_height + 3;
	  clearcount++;
#else
	  clearzone[0][clearcount] = dx - (shield_width / 2);
	  clearzone[1][clearcount] = dy - (shield_height / 2);
	  clearzone[2][clearcount] = shield_width;
	  clearzone[3][clearcount] = shield_height;
	  clearcount++;
#endif

	  if (j->p_team == ROM && j->p_ship.s_type == CRUISER &&
	      ROMVLVS)
	    W_WriteBitmap (dx - (j->p_ship.s_width / 2),
			   dy - (j->p_ship.s_height / 2), ROMVLVS_bitmap[rosette (j->p_dir)],
			   playerColor (j));
	  else
	    W_WriteBitmap (dx - (j->p_ship.s_width / 2),
			   dy - (j->p_ship.s_height / 2),
#ifndef DYNAMIC_BITMAPS
			   ship_bits[j->p_ship.s_type][rosette (j->p_dir)],
#else
			 ship_bitmaps[PlayerBitmap (j)][rosette (j->p_dir)],
#endif
			   playerColor (j));

	  if (j->p_cloakphase > 0)
	    {
	      W_WriteBitmap (dx - (cloak_width / 2),
		       dy - (cloak_height / 2), cloakicon, playerColor (j));
	      if (!myPlayer (j))/* if myplayer draw the shield */
		continue;
	    }

	shieldlabel:
#ifdef VARY_HULL
	  if (j == me && vary_hull)
	    {
	      int hull_left = (100 * (me->p_ship.s_maxdamage -
		      me->p_damage)) / me->p_ship.s_maxdamage, hull_num = 7;
	      int hull_color;

	      if (hull_left <= 16)
		{
		  hull_num = 0;
		  hull_color = W_Red;
		}
	      else if (hull_left <= 28)
		{
		  hull_num = 1;
		  hull_color = W_Yellow;
		}
	      else if (hull_left <= 40)
		{
		  hull_num = 2;
		  hull_color = W_Green;
		}
	      else if (hull_left <= 52)
		{
		  hull_num = 3;
		  hull_color = W_Green;
		}
	      else if (hull_left <= 64)
		{
		  hull_num = 4;
		  hull_color = W_Green;
		}
	      else if (hull_left <= 76)
		{
		  hull_num = 5;
		  hull_color = W_White;
		}
	      else if (hull_left <= 88)
		{
		  hull_num = 6;
		  hull_color = W_White;
		}
	      else
		hull_color = playerColor (j);

	      W_WriteBitmap (dx - (shield_width / 2 + 1),
			     dy - (shield_height / 2 + 1),
			     hull[hull_num], hull_color);
	    }
#endif

#ifdef SOUND
	  if (j->p_no == me->p_no)
	    {
	      if ((sound_flags & PFSHIELD) && !(j->p_flags & PFSHIELD))
		Play_Sound (SHIELD_DOWN_SOUND);
	      if (!(sound_flags & PFSHIELD) && (j->p_flags & PFSHIELD))
		Play_Sound (SHIELD_UP_SOUND);
	    }
#endif

	  if (showShields && (j->p_flags & PFSHIELD))
	    {
#ifdef VSHIELD_BITMAPS
	      int color;
	      int shieldnum;
	      if (j == me && VShieldBitmaps)
		{
		  shieldnum = SHIELD_FRAMES * me->p_shield / me->p_ship.s_maxshield;
		  if (shieldnum >= SHIELD_FRAMES)
		    shieldnum = SHIELD_FRAMES - 1;
		  color = gColor;
		  if (shieldnum < SHIELD_FRAMES * 2 / 3)
		    {
		      color = yColor;
		      if (shieldnum < SHIELD_FRAMES * 2 / 3)
			{
			  color = rColor;
			}
		    }
		}
	      else
		{
		  color = playerColor (j);
		  shieldnum = 2;
		}
	      W_WriteBitmap (dx - (shield_width / 2),
			dy - (shield_height / 2), shield[shieldnum], color);
#else
	      if (warnShields && j == me)
		{
		  int color = gColor;
		  switch (me->p_flags & (PFGREEN | PFYELLOW | PFRED))
		    {
		    case PFGREEN:
		      color = gColor;
		      break;
		    case PFYELLOW:
		      color = yColor;
		      break;
		    case PFRED:
		      color = rColor;
		      break;
		    }
		  W_WriteBitmap (dx - (shield_width / 2),
				 dy - (shield_height / 2), shield, color);
		}
	      else
		{
		  W_WriteBitmap (dx - (shield_width / 2),
			 dy - (shield_height / 2), shield, playerColor (j));
		}
#endif
	    }
	  if (j->p_flags & PFCLOAK)	/* when cloaked stop here */
	    continue;

	  {
	    int color = playerColor (j);
	    idbuf[0] = *(shipnos + j->p_no);

	    if (j == me)
	      {
		switch (me->p_flags & (PFGREEN | PFYELLOW | PFRED))
		  {
		  case PFGREEN:
		    color = gColor;
		    break;
		  case PFYELLOW:
		    color = yColor;
		    break;
		  case PFRED:
		    color = rColor;
		    break;
		  }
	      }
	    W_MaskText (w, dx + (j->p_ship.s_width / 2),
			dy - (j->p_ship.s_height / 2), color,
			idbuf, 1, shipFont (j));

	    clearzone[0][clearcount] = dx + (j->p_ship.s_width / 2);
	    clearzone[1][clearcount] = dy - (j->p_ship.s_height / 2);
	    clearzone[2][clearcount] = W_Textwidth;
	    clearzone[3][clearcount] = W_Textheight;
	    clearcount++;
	  }

	}
      else if (j->p_status == PEXPLODE)
	{
	  int i;

	  i = j->p_explode;
#ifdef SOUND
	  if (i == 1)
	    explode_sound = 1;
#endif
	  if (i < EX_FRAMES || (i < SBEXPVIEWS && j->p_ship.s_type == STARBASE))
	    {

	      if (j->p_ship.s_type == STARBASE)
		{
		  W_WriteBitmap (dx - (sbexp_width / 2),
				 dy - (sbexp_height / 2), sbexpview[i],
				 playerColor (j));
		  clearzone[0][clearcount] = dx - (sbexp_width / 2);
		  clearzone[1][clearcount] = dy - (sbexp_height / 2);
		  clearzone[2][clearcount] = sbexp_width;
		  clearzone[3][clearcount] = sbexp_height;
		}
	      else
		{
		  W_WriteBitmap (dx - (ex_width / 2), dy - (ex_height / 2),
				 expview[i], playerColor (j));
		  clearzone[0][clearcount] = dx - (ex_width / 2);
		  clearzone[1][clearcount] = dy - (ex_height / 2);
		  clearzone[2][clearcount] = ex_width;
		  clearzone[3][clearcount] = ex_height;
		}
	      clearcount++;
	      j->p_explode++;
	    }
	}
      /* Now draw his phaser (if it exists) */
      php = &phasers[j->p_no];
      if (php->ph_status != PHFREE)
	{
	  if (php->ph_status == PHMISS)
	    {
	      /* Here I will have to compute end coordinate */
	      tx = j->p_x + PHASEDIST * j->p_ship.s_phaserdamage / 100 * Cos[php->ph_dir];
	      ty = j->p_y + PHASEDIST * j->p_ship.s_phaserdamage / 100 * Sin[php->ph_dir];
	      tx = (tx - me->p_x) / SCALE + WINSIDE / 2;
	      ty = (ty - me->p_y) / SCALE + WINSIDE / 2;
	      px = j->p_x + PHASEDIST * j->p_ship.s_phaserdamage / 100 * Cos[php->ph_dir];
	      py = j->p_y + PHASEDIST * j->p_ship.s_phaserdamage / 100 * Sin[php->ph_dir];
	      px = (px - me->p_x) / SCALE + WINSIDE / 2;
	      py = (py - me->p_y) / SCALE + WINSIDE / 2;
	      php->ph_fuse = 0;
	    }
	  else if (php->ph_status == PHHIT2)
	    {
	      tx = (php->ph_x - me->p_x) / SCALE + WINSIDE / 2;
	      ty = (php->ph_y - me->p_y) / SCALE + WINSIDE / 2;
	      px = (php->ph_x - me->p_x) / SCALE + WINSIDE / 2;
	      py = (php->ph_y - me->p_y) / SCALE + WINSIDE / 2;
	    }
	  else
	    {			/* Start point is dx, dy */
	      tx = (players[php->ph_target].p_x - me->p_x) /
		SCALE + WINSIDE / 2;
	      ty = (players[php->ph_target].p_y - me->p_y) /
		SCALE + WINSIDE / 2;
	      px = (players[php->ph_target].p_x - me->p_x) /
		SCALE + WINSIDE / 2;
	      py = (players[php->ph_target].p_y - me->p_y) /
		SCALE + WINSIDE / 2;
#ifdef SOUND
	      if ((j->p_no == me->p_no) && (!p_sound))
		{
		  Play_Sound (PHASER_SOUND);
		  p_sound++;
		}
#endif
	    }

	  if (friendlyPlayer (j))
	    {
	      if ((php->ph_fuse % 2) == 1)
		W_CacheLine (w, dx, dy, tx, ty, foreColor);
	      else
		W_CacheLine (w, dx, dy, tx, ty, shipCol[remap[j->p_team]]);
	      php->ph_fuse++;

	      clearline[0][clearlcount] = dx;
	      clearline[1][clearlcount] = dy;
	      clearline[2][clearlcount] = tx;
	      clearline[3][clearlcount] = ty;
	      clearlcount++;
	    }
	  else
	    {
	      if ((enemyPhasers > 0) && (enemyPhasers <= 10))
		{
		  register int lx, ly;

		  if (px == dx && py == dy)
		    continue;

		  wx = dx + enemyPhasers * Cos[NORMALIZE (php->ph_dir + 64)];
		  wy = dy + enemyPhasers * Sin[NORMALIZE (php->ph_dir + 64)];
		  lx = dx + enemyPhasers * Cos[NORMALIZE (php->ph_dir - 64)];
		  ly = dy + enemyPhasers * Sin[NORMALIZE (php->ph_dir - 64)];

		  W_MakePhaserLine (w, wx, wy, px, py, shipCol[remap[j->p_team]]);
		  W_MakePhaserLine (w, lx, ly, px, py, shipCol[remap[j->p_team]]);

		  php->ph_fuse++;

		  clearline[0][clearlcount] = wx;
		  clearline[1][clearlcount] = wy;
		  clearline[2][clearlcount] = px;
		  clearline[3][clearlcount] = py;
		  clearlcount++;

		  clearline[0][clearlcount] = lx;
		  clearline[1][clearlcount] = ly;
		  clearline[2][clearlcount] = px;
		  clearline[3][clearlcount] = py;
		  clearlcount++;
		}
	      else
		{
		  W_MakePhaserLine (w, dx, dy, px, py, shipCol[remap[j->p_team]]);

		  php->ph_fuse++;

		  clearline[0][clearlcount] = dx;
		  clearline[1][clearlcount] = dy;
		  clearline[2][clearlcount] = px;
		  clearline[3][clearlcount] = py;
		  clearlcount++;
		}
	    }
	}
#ifdef SOUND
      else if (j->p_no == me->p_no)
	p_sound = 0;
#endif

      /* ATM - show tractor/pressor beams (modified by James Collins) */
      /* showTractorPressor is a variable set by xtrekrc. */
    tract:if (showTractorPressor)
	{
	  if (myPlayer (j) && isAlive (me) && (j->p_flags & PFTRACT || j->p_flags & PFPRESS))
	    {
	      double theta;
	      unsigned char dir;
	      int lx[2], ly[2], px, py, target_width;

	      struct player *tractee;
	      if (me->p_tractor < 0 || me->p_tractor >= MAXPLAYER)
		continue;
	      tractee = &players[me->p_tractor];
	      if (tractee->p_status != PALIVE ||
		  ((tractee->p_flags & PFCLOAK) && (tractee->p_cloakphase == (CLOAK_PHASES - 1))))
		continue;
	      if (tcounter >= 2)
		{		/* continue tractor stuff */
		  if (!continuetractor)
		    tcounter--;
		  px = (players[me->p_tractor].p_x - me->p_x) / SCALE + WINSIDE / 2;
		  py = (players[me->p_tractor].p_y - me->p_y) / SCALE + WINSIDE / 2;
		  if (px == dx && py == dy)
		    continue;	/* this had better be last in for(..) */
#define XPI     3.1415926
		  theta = atan2 ((double) (px - dx), (double) (dy - py)) + XPI / 2.0;
		  dir = (unsigned char) (theta / XPI * 128.0);
		  if (tractee->p_flags & PFSHIELD)
		    target_width = shield_width;
		  else
		    {
		      target_width = tractee->p_ship.s_width / 2;
		    }
		  lx[0] = px + (Cos[dir] * (target_width / 2));
		  ly[0] = py + (Sin[dir] * (target_width / 2));
		  lx[1] = px - (Cos[dir] * (target_width / 2));
		  ly[1] = py - (Sin[dir] * (target_width / 2));
#undef XPI
		  if (j->p_flags & PFPRESS)
		    {
		      W_MakeTractLine (w, dx, dy, lx[0], ly[0], W_Yellow);
		      W_MakeTractLine (w, dx, dy, lx[1], ly[1], W_Yellow);
		    }
		  else
		    {
		      W_MakeTractLine (w, dx, dy, lx[0], ly[0], W_Green);
		      W_MakeTractLine (w, dx, dy, lx[1], ly[1], W_Green);
		    }
		  clearline[0][clearlcount] = dx;
		  clearline[1][clearlcount] = dy;
		  clearline[2][clearlcount] = lx[0];
		  clearline[3][clearlcount] = ly[0];
		  clearlcount++;
		  clearline[0][clearlcount] = dx;
		  clearline[1][clearlcount] = dy;
		  clearline[2][clearlcount] = lx[1];
		  clearline[3][clearlcount] = ly[1];
		  clearlcount++;
		}
	    }
	  else if (!(me->p_flags & PFPRESS || me->p_flags & PFTRACT))
	    tcounter = 2;
	}
    }
  /* Draw torps */
#ifdef SOUND
  if (sound_torps < me->p_ntorp)
    Play_Sound (FIRE_TORP_SOUND);
#endif
  view = SCALE * WINSIDE / 2;
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (!j->p_ntorp)
	continue;
      for (h = 0, k = &torps[MAXTORP * i + h]; h < MAXTORP; h++, k++)
	{
	  if (!k->t_status)
	    continue;
	  dx = k->t_x - me->p_x;
	  dy = k->t_y - me->p_y;
	  if (dx > view || dx < -view || dy > view || dy < -view)
	    {
	      /* Call any torps off screen "free" (if owned by other) */
	      if (k->t_status == TEXPLODE && j != me)
		{
		  k->t_status = TFREE;
		  j->p_ntorp--;
		}
	      continue;
	    }
	  dx = dx / SCALE + WINSIDE / 2;
	  dy = dy / SCALE + WINSIDE / 2;
	  if (k->t_status == TEXPLODE)
	    {
	      k->t_fuse--;
	      if (k->t_fuse <= 0)
		{
		  k->t_status = TFREE;
		  j->p_ntorp--;
		  continue;
		}
	      if (k->t_fuse >= NUMDETFRAMES)
		{
		  k->t_fuse = NUMDETFRAMES - 1;
		}
#ifdef SOUND
	      if (k->t_fuse == NUMDETFRAMES - 1)
		Play_Sound (TORP_HIT_SOUND);
#endif
	      W_WriteBitmap (dx - (cloud_width / 2), dy - (cloud_height / 2),
			     cloud[k->t_fuse], torpColor (k));
	      clearzone[0][clearcount] = dx - (cloud_width / 2);
	      clearzone[1][clearcount] = dy - (cloud_height / 2);
	      clearzone[2][clearcount] = cloud_width;
	      clearzone[3][clearcount] = cloud_height;
	      clearcount++;
	    }
	  else if (k->t_owner != me->p_no && ((k->t_war & me->p_team) ||
	       (players[k->t_owner].p_team & (me->p_hostile | me->p_swar))))
	    {
	      /*
	         solid.  Looks strange.
	         W_FillArea(w, dx - (etorp_width/2), dy - (etorp_height/2),
	         etorp_width, etorp_height, torpColor(k));
	       */

	      /* XFIX */
	      W_CacheLine (w, dx - (etorp_width / 2), dy - (etorp_height / 2),
			   dx + (etorp_width / 2), dy + (etorp_height / 2), torpColor (k));
	      W_CacheLine (w, dx + (etorp_width / 2), dy - (etorp_height / 2),
			   dx - (etorp_width / 2), dy + (etorp_height / 2), torpColor (k));

	      /*
	         W_WriteBitmap(dx - (etorp_width/2), dy - (etorp_height/2),
	         etorp, torpColor(k));
	       */
	      clearzone[0][clearcount] = dx - (etorp_width / 2);
	      clearzone[1][clearcount] = dy - (etorp_height / 2);
	      clearzone[2][clearcount] = etorp_width;
	      clearzone[3][clearcount] = etorp_height;
	      clearcount++;
	    }
	  else
	    {

	      W_CacheLine (w, dx - (mtorp_width / 2), dy, dx + (mtorp_width / 2), dy,
			   torpColor (k));
	      W_CacheLine (w, dx, dy - (mtorp_width / 2), dx, dy + (mtorp_width / 2),
			   torpColor (k));

	      /*
	         W_WriteBitmap(dx - (mtorp_width/2), dy - (mtorp_height/2),
	         mtorp, torpColor(k));
	       */
	      clearzone[0][clearcount] = dx - (mtorp_width / 2);
	      clearzone[1][clearcount] = dy - (mtorp_height / 2);
	      clearzone[2][clearcount] = mtorp_width;
	      clearzone[3][clearcount] = mtorp_height;
	      clearcount++;
	    }
	}
    }
  /* Draw plasma torps */
  view = SCALE * WINSIDE / 2;
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      if (!j->p_nplasmatorp)
	continue;
      for (h = 0, pt = &plasmatorps[MAXPLASMA * i + h]; h < MAXPLASMA; h++, pt++)
	{
	  if (!pt->pt_status)
	    continue;
	  dx = pt->pt_x - me->p_x;
	  dy = pt->pt_y - me->p_y;
	  if (dx > view || dx < -view || dy > view || dy < -view)
	    continue;
	  dx = dx / SCALE + WINSIDE / 2;
	  dy = dy / SCALE + WINSIDE / 2;
	  if (pt->pt_status == PTEXPLODE)
	    {
	      pt->pt_fuse--;
	      if (pt->pt_fuse <= 0)
		{
		  pt->pt_status = PTFREE;
		  j->p_nplasmatorp--;
		  continue;
		}
	      if (pt->pt_fuse >= NUMDETFRAMES)
		{
		  pt->pt_fuse = NUMDETFRAMES - 1;
		}
	      W_WriteBitmap (dx - (plasmacloud_width / 2),
			     dy - (plasmacloud_height / 2),
			     plasmacloud[pt->pt_fuse], plasmatorpColor (pt));
	      clearzone[0][clearcount] = dx - (plasmacloud_width / 2);
	      clearzone[1][clearcount] = dy - (plasmacloud_height / 2);
	      clearzone[2][clearcount] = plasmacloud_width;
	      clearzone[3][clearcount] = plasmacloud_height;
	      clearcount++;
	    }
	  /* needmore: if(pt->pt_war & me->p_team) */
	  else if (pt->pt_owner != me->p_no && ((pt->pt_war & me->p_team) ||
	     (players[pt->pt_owner].p_team & (me->p_hostile | me->p_swar))))
	    {
	      W_WriteBitmap (dx - (eplasmatorp_width / 2),
			     dy - (eplasmatorp_height / 2),
			     eplasmatorp, plasmatorpColor (pt));
	      clearzone[0][clearcount] = dx - (eplasmatorp_width / 2);
	      clearzone[1][clearcount] = dy - (eplasmatorp_height / 2);
	      clearzone[2][clearcount] = eplasmatorp_width;
	      clearzone[3][clearcount] = eplasmatorp_height;
	      clearcount++;
	    }
	  else
	    {
	      W_WriteBitmap (dx - (mplasmatorp_width / 2),
			     dy - (mplasmatorp_height / 2),
			     mplasmatorp, plasmatorpColor (pt));
	      clearzone[0][clearcount] = dx - (mplasmatorp_width / 2);
	      clearzone[1][clearcount] = dy - (mplasmatorp_height / 2);
	      clearzone[2][clearcount] = mplasmatorp_width;
	      clearzone[3][clearcount] = mplasmatorp_height;
	      clearcount++;
	    }
	}
    }

  /* Draw Hockey Lines */
#ifdef HOCKEY_LINES
   if (hockey_s_lines && 1)
   for (i = 0, sl = &s_lines[i]; i < NUM_HOCKEY_LINES; i++, sl++) {
     
     /* Treat the line differently based on the orientation */
     if ( sl->orientation == S_LINE_VERTICAL ) {
       if (((sx = (sl->begin_x-me->p_x)/SCALE)<HALF_WINSIDE) && (sx>-HALF_WINSIDE)) {
	 sx += HALF_WINSIDE; ex = sx;
	 if ( (sy = HALF_WINSIDE - (me->p_y - sl->begin_y)/SCALE) < 0 ) sy = 0;
	 if ( sy > (WINSIDE - 1) ) sy = WINSIDE - 1;
	 if ( (ey = HALF_WINSIDE - (me->p_y - sl->end_y)/SCALE)   < 0 ) ey = 0;
	 if ( ey > (WINSIDE - 1) ) ey = WINSIDE - 1;
	 if ( sy == ey ) continue;
       }
       else continue;
     }
     else if ( sl->orientation == S_LINE_HORIZONTAL ) {
       if (((sy = (sl->begin_y-me->p_y)/SCALE )<HALF_WINSIDE) && (sy>-HALF_WINSIDE)) {
	 sy += HALF_WINSIDE; ey = sy;
	 if ( (sx = HALF_WINSIDE - (me->p_x - sl->begin_x)/SCALE) < 0 ) sx = 0;
	 if ( sx > (WINSIDE - 1) ) sx = WINSIDE - 1;
	 if ( (ex = HALF_WINSIDE - (me->p_x - sl->end_x)/SCALE)   < 0 ) ex = 0;
	 if ( ex > (WINSIDE - 1) ) ex = WINSIDE - 1;
	 if ( sx == ex ) continue;
       }
       else continue;
     }
     else
       continue;

     W_CacheLine(w, sx, sy, ex, ey, sl->color);
     clearline[0][clearlcount] = sx;
     clearline[1][clearlcount] = sy;
     clearline[2][clearlcount] = ex;
     clearline[3][clearlcount] = ey;
     clearlcount++;
   }  /*End for Hockey Lines*/  /*Ends the if, too*/

#endif  /*HOCKEY_LINES*/

  /* Draw Edges */
  if (me->p_x < (WINSIDE / 2) * SCALE)
    {
      int sy, ey;

      dx = (WINSIDE / 2) - (me->p_x) / SCALE;
      sy = (WINSIDE / 2) + (0 - me->p_y) / SCALE;
      ey = (WINSIDE / 2) + (GWIDTH - me->p_y) / SCALE;
      if (sy < 0)
	sy = 0;
      if (ey > WINSIDE - 1)
	ey = WINSIDE - 1;
      /* XFIX */
      W_CacheLine (w, dx, sy, dx, ey, warningColor);
      /*
         W_MakeLine(w, dx, sy, dx, ey, warningColor);
       */
      clearline[0][clearlcount] = dx;
      clearline[1][clearlcount] = sy;
      clearline[2][clearlcount] = dx;
      clearline[3][clearlcount] = ey;
      clearlcount++;
    }
  if ((GWIDTH - me->p_x) < (WINSIDE / 2) * SCALE)
    {
      int sy, ey;

      dx = (WINSIDE / 2) + (GWIDTH - me->p_x) / SCALE;
      sy = (WINSIDE / 2) + (0 - me->p_y) / SCALE;
      ey = (WINSIDE / 2) + (GWIDTH - me->p_y) / SCALE;
      if (sy < 0)
	sy = 0;
      if (ey > WINSIDE - 1)
	ey = WINSIDE - 1;
      /* XFIX */
      W_CacheLine (w, dx, sy, dx, ey, warningColor);
      /*
         W_MakeLine(w, dx, sy, dx, ey, warningColor);
       */
      clearline[0][clearlcount] = dx;
      clearline[1][clearlcount] = sy;
      clearline[2][clearlcount] = dx;
      clearline[3][clearlcount] = ey;
      clearlcount++;
    }
  if (me->p_y < (WINSIDE / 2) * SCALE)
    {
      int sx, ex;

      dy = (WINSIDE / 2) - (me->p_y) / SCALE;
      sx = (WINSIDE / 2) + (0 - me->p_x) / SCALE;
      ex = (WINSIDE / 2) + (GWIDTH - me->p_x) / SCALE;
      if (sx < 0)
	sx = 0;
      if (ex > WINSIDE - 1)
	ex = WINSIDE - 1;
      /* XFIX */
      W_CacheLine (w, sx, dy, ex, dy, warningColor);
      /*
         W_MakeLine(w, sx, dy, ex, dy, warningColor);
       */
      clearline[0][clearlcount] = sx;
      clearline[1][clearlcount] = dy;
      clearline[2][clearlcount] = ex;
      clearline[3][clearlcount] = dy;
      clearlcount++;
    }
  if ((GWIDTH - me->p_y) < (WINSIDE / 2) * SCALE)
    {
      int sx, ex;

      dy = (WINSIDE / 2) + (GWIDTH - me->p_y) / SCALE;
      sx = (WINSIDE / 2) + (0 - me->p_x) / SCALE;
      ex = (WINSIDE / 2) + (GWIDTH - me->p_x) / SCALE;
      if (sx < 0)
	sx = 0;
      if (ex > WINSIDE - 1)
	ex = WINSIDE - 1;
      /* XFIX */
      W_CacheLine (w, sx, dy, ex, dy, warningColor);
      /*
         W_MakeLine(w, sx, dy, ex, dy, warningColor);
       */
      clearline[0][clearlcount] = sx;
      clearline[1][clearlcount] = dy;
      clearline[2][clearlcount] = ex;
      clearline[3][clearlcount] = dy;
      clearlcount++;
    }


  /* Change border color to signify alert status */

  if (oldalert != (me->p_flags & (PFGREEN | PFYELLOW | PFRED)))
    {
      oldalert = (me->p_flags & (PFGREEN | PFYELLOW | PFRED));
      switch (oldalert)
	{
	case PFGREEN:
	  if (extraBorder)
	    W_ChangeBorder (w, gColor);
	  W_ChangeBorder (baseWin, gColor);
	  W_ChangeBorder (iconWin, gColor);
#ifdef SOUND
	  Abort_Sound (WARNING_SOUND);
#endif
	  break;
	case PFYELLOW:
	  if (extraBorder)
	    W_ChangeBorder (w, yColor);
	  W_ChangeBorder (baseWin, yColor);
	  W_ChangeBorder (iconWin, yColor);
#ifdef SOUND
	  Abort_Sound (WARNING_SOUND);
#endif
	  break;
	case PFRED:
	  if (extraBorder)
	    W_ChangeBorder (w, rColor);
	  W_ChangeBorder (baseWin, rColor);
	  W_ChangeBorder (iconWin, rColor);
#ifdef SOUND
	  Play_Sound (WARNING_SOUND);
#endif
	  break;
	}
    }
#ifdef SOUND
  sound_flags = me->p_flags;
  sound_torps = me->p_ntorp;
  if (explode_sound)
    {				/* Highest Priority */
      Play_Sound (EXPLOSION_SOUND);
      explode_sound = 0;
    }
#endif

  /* show 'lock' icon on local map (Actually an EM hack ) */
  if (showLock & 2)
    {
      int tri_x = -1, tri_y = -1, facing = 0;
      int tri_size = 4;
      view = SCALE * WINSIDE / 2;	/** just in case it's changed */
      if (me->p_flags & PFPLOCK)
	{
	  /* locked onto a ship */
	  j = &players[me->p_playerl];
	  if (!(j->p_flags & PFCLOAK))
	    {
	      dx = j->p_x - me->p_x;
	      dy = j->p_y - me->p_y;
	      if (ABS (dx) < view && ABS (dy) < view)
		{
		  dx = dx / SCALE + WINSIDE / 2;
		  dy = dy / SCALE + WINSIDE / 2;
		  tri_x = dx + 0;
		  tri_y = dy + 20;	/* below ship */
		  facing = 1;
		}
	      /* printf("Drawing local triangle at %d %d\n", tri_x, tri_y); */
	    }
	}
      else if (me->p_flags & PFPLLOCK)
	{
	  /* locked onto a planet */
	  struct planet *l = &planets[me->p_planet];
	  dx = l->pl_x - me->p_x;
	  dy = l->pl_y - me->p_y;
	  if (ABS (dx) < view && ABS (dy) < view)
	    {
	      dx = dx / SCALE + WINSIDE / 2;
	      dy = dy / SCALE + WINSIDE / 2;
	      tri_x = dx;
	      tri_y = dy - 20;	/* below planet */
	      facing = 0;
	    }
	  /* printf("Drawing local triangle at %d %d\n", tri_x, tri_y); */
	}
      if (tri_x != -1)
	{
	  W_WriteTriangle (w, tri_x, tri_y, 4, facing, foreColor);
	  clearzone[0][clearcount] = tri_x - tri_size - 1;
	  clearzone[1][clearcount] = tri_y - 1 +
	    (facing ? 0 : -tri_size);
	  clearzone[2][clearcount] = tri_size * 2 + 2;
	  clearzone[3][clearcount] = tri_size + 2;
	  clearcount++;
	}
    }
}

/* map out the 'galactic' map */
map ()
{
  register int i;
  register struct player *j;
  register struct planet *l;
  register int dx, dy, odx, ody;
  int color, pl;

  if (redrawall)
    W_ClearWindow (mapw);
  else
    {				/* Erase ships */
      for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
	{
	  lastUpdate[i]++;
	  /* Erase the guy if:
	 * redrawPlayer[i] is set and the mapmode setting allows it.
	 */
	  if (!redrawPlayer[i] || (mapmode == 1 && lastUpdate[i] < 5))
	    continue;
	  lastUpdate[i] = 0;
	  /* Clear his old image... */
	  if (mclearzone[2][i])
	    {
	      /* XFIX */
	      W_ClearArea (mapw, mclearzone[0][i], mclearzone[1][i],
			   mclearzone[2][i], mclearzone[3][i]);
	      /* Redraw the hole just left next update */
	      checkRedraw (mclearzone[4][i], mclearzone[5][i]);
	      mclearzone[2][i] = 0;
	    }
	}

#ifdef BRMH
      if (clearlmcount)
	{
	  W_WriteTriangle (mapw, clearlmark[0], clearlmark[1], 4, 0, backColor);
	  clearlmcount--;
	}
#endif
    }

  /* Draw Planets */
  for (i = 0, l = &planets[i]; i < MAXPLANETS; i++, l++)
    {
      if (!(l->pl_flags & PLREDRAW) && (!redrawall))
	continue;
      l->pl_flags &= ~PLREDRAW;	/* Turn redraw flag off! */
      dx = l->pl_x * WINSIDE / GWIDTH;
      dy = l->pl_y * WINSIDE / GWIDTH;

      /* moving planets */
      if (pl_update[l->pl_no].plu_update == 1)
	{

	  odx = pl_update[l->pl_no].plu_x * WINSIDE / GWIDTH;
	  ody = pl_update[l->pl_no].plu_y * WINSIDE / GWIDTH;

	  /* XFIX */
	  W_ClearArea (mapw, odx - (mplanet_width / 2), ody - (mplanet_height / 2),
		       mplanet_width, mplanet_height);
	  W_WriteText (mapw, odx - (mplanet_width / 2), ody + (mplanet_height / 2),
		       backColor, l->pl_name, 3, planetFont (l));

	  pl_update[l->pl_no].plu_update = 0;
	}
      else
#ifdef BRMH
      if (redrawall == 2 || (l->pl_flags & PLCLEAR))
	{
	  /* XFIX */
	  W_ClearArea (mapw, dx - (mplanet_width / 2), dy - (mplanet_height / 2), +mplanet_width, mplanet_height);
	  l->pl_flags &= ~PLCLEAR;
	}
#else
	/* XFIX */
	W_ClearArea (mapw, dx - (mplanet_width / 2), dy - (mplanet_height / 2),
		     mplanet_width, mplanet_height);
#endif

      W_WriteBitmap (dx - (mplanet_width / 2), dy - (mplanet_height / 2),
		     planetmBitmap (l), planetColor (l));
      W_WriteText (mapw, dx - (mplanet_width / 2), dy + (mplanet_height / 2),
		   planetColor (l), l->pl_name, 3, planetFont (l));

      if (showIND && (l->pl_info & me->p_team) && (l->pl_owner == NOBODY))
	{
	  W_MakeLine (mapw, dx + (mplanet_width / 2 - 1), dy + (mplanet_height / 2 - 1),
		      dx - (mplanet_width / 2), dy - (mplanet_height / 2),
		      W_White);
	  W_MakeLine (mapw, dx - (mplanet_width / 2), dy + (mplanet_height / 2 - 1),
		    dx + (mplanet_width / 2 - 1), dy - (mplanet_height / 2),
		      W_White);
	}
    }
  /* Draw ships */
  for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++)
    {
      /* We draw the guy if redrawall, or we just erased him.
         * Also, we redraw if we haven't drawn for 30 frames.
         * (in case he was erased by other ships).
       */
      if (lastUpdate[i] != 0 && (!redrawall) && lastUpdate[i] < 30)
	continue;
      if (j->p_status != PALIVE)
	continue;
      if (j->p_flags & PFOBSERV)
	continue;		/* jmn - observer support */
      lastUpdate[i] = 0;
      dx = j->p_x * WINSIDE / GWIDTH;
      dy = j->p_y * WINSIDE / GWIDTH;


#ifdef BRMH
      if ((showLock & 1) && !(j->p_flags & PFCLOAK))
	if ((me->p_flags & PFPLOCK) && (me->p_playerl == j->p_no))
	  pl = 1;
#endif

      if (j->p_flags & PFCLOAK)
	{
	  W_WriteText (mapw, dx - W_Textwidth,
		       dy - W_Textheight / 2, unColor, cloakChars,
		       (cloakChars[1] == '\0' ? 1 : 2), W_RegularFont);
	}
      else
	{
	  W_WriteText (mapw, dx - W_Textwidth,
		   dy - W_Textheight / 2, playerColor (j), j->p_mapchars, 2,
		       shipFont (j));
	}

      mclearzone[0][i] = dx - W_Textwidth;
      mclearzone[1][i] = dy - W_Textheight / 2;
      mclearzone[2][i] = W_Textwidth * 2;
      if (pl)
	mclearzone[3][i] = W_Textheight + 8;
      else
	mclearzone[3][i] = W_Textheight;
      /* Set these so we can checkRedraw() next time */
      mclearzone[4][i] = j->p_x;
      mclearzone[5][i] = j->p_y;
      redrawPlayer[i] = 0;
    }

#ifdef BRMH
  if ((me->p_flags & PFPLOCK) && (showLock & 1))
    {
      j = &players[me->p_playerl];

      if (j->p_status == PALIVE && !(j->p_flags & PFCLOAK))
	{
	  dx = j->p_x * WINSIDE / GWIDTH;
	  dy = j->p_y * WINSIDE / GWIDTH;
	  W_WriteTriangle (mapw, dx, dy + 6, 4, 1, foreColor);

	  clearlmark[0] = dx;
	  clearlmark[1] = dy + 6;
	  clearlmark[2] = 4;
	  clearlmark[3] = 1;
	  clearlmcount++;
	}
    }
  else if ((me->p_flags & PFPLLOCK) && (showLock & 1))
    {
      struct planet *l = &planets[me->p_planet];

      dx = l->pl_x * WINSIDE / GWIDTH;
      dy = l->pl_y * WINSIDE / GWIDTH;
      W_WriteTriangle (mapw, dx, dy - (mplanet_height) / 2 - 4, 4, 0, foreColor);
      clearlmark[0] = dx;
      clearlmark[1] = dy - (mplanet_height) / 2 - 4;
      clearlmark[2] = 4;
      clearlmark[3] = 0;
      clearlmcount++;
    }
#endif /* TSH */
  redrawall = 0;
}

stline (flag)
     int flag;
{
  static char buf1[80];
  static char buf2[80];
  static char whichbuf = 0;
  register char *buf, *oldbuf;
  register char *s;
  register int i, j;
  int k;

  /* Instead of one sprintf, we do all this by hand for optimization */

  if (flag)
    whichbuf = 0;		/* We must completely refresh */

  if (whichbuf != 2)
    {
      buf = buf1;
      oldbuf = buf2;
    }
  else
    {
      buf = buf2;
      oldbuf = buf1;
    }
  buf[0] = (me->p_flags & PFSHIELD ? 'S' : ' ');
  if (me->p_flags & PFGREEN)
    buf[1] = 'G';
  else if (me->p_flags & PFYELLOW)
    buf[1] = 'Y';
  else if (me->p_flags & PFRED)
    buf[1] = 'R';
  buf[2] = (me->p_flags & (PFPLLOCK | PFPLOCK) ? 'L' : ' ');
  buf[3] = (me->p_flags & PFREPAIR ? 'R' : ' ');
  buf[4] = (me->p_flags & PFBOMB ? 'B' : ' ');
  buf[5] = (me->p_flags & PFORBIT ? 'O' : ' ');
  if (me->p_ship.s_type == STARBASE)
    buf[6] = (me->p_flags & PFDOCKOK ? 'D' : ' ');
  else
    buf[6] = (me->p_flags & PFDOCK ? 'D' : ' ');
  buf[7] = (me->p_flags & PFCLOAK ? 'C' : ' ');
  buf[8] = (me->p_flags & PFWEP ? 'W' : ' ');
  buf[9] = (me->p_flags & PFENG ? 'E' : ' ');
  if (me->p_flags & PFPRESS)
    buf[10] = 'P';
  else if (me->p_flags & PFTRACT)
    buf[10] = 'T';
  else
    buf[10] = ' ';
  if (me->p_flags & PFBEAMUP)
    buf[11] = 'u';
  else if (me->p_flags & PFBEAMDOWN)
    buf[11] = 'd';
  else
    buf[11] = ' ';
  buf[12] = (status->tourn) ? 't' : ' ';
  buf[13] = ' ';
  buf[14] = '0' + ((me->p_speed % 100) / 10);
  if (buf[14] == '0')
    buf[14] = ' ';
  buf[15] = '0' + (me->p_speed % 10);	/* speed */
  buf[16] = ' ';
  buf[17] = ' ';
  buf[18] = '0' + (me->p_damage / 100);
  if (buf[18] == '0')
    buf[18] = ' ';
  buf[19] = '0' + ((me->p_damage % 100) / 10);
  if ((buf[19] == '0') && (me->p_damage < 100))
    buf[19] = ' ';
  buf[20] = '0' + (me->p_damage % 10);
  buf[21] = ' ';
  buf[22] = '0' + (me->p_shield / 100);
  if (buf[22] == '0')
    buf[22] = ' ';
  buf[23] = '0' + ((me->p_shield % 100) / 10);
  if ((buf[23] == '0') && (me->p_shield < 100))
    buf[23] = ' ';
  buf[24] = '0' + (me->p_shield % 10);
  buf[25] = ' ';
  buf[26] = ' ';
  buf[27] = '0' + ((me->p_ntorp % 100) / 10);
  if (buf[27] == '0')
    buf[27] = ' ';
  buf[28] = '0' + (me->p_ntorp % 10);
  buf[29] = ' ';
  buf[30] = ' ';
  buf[31] = ' ';
  buf[32] = ' ';
  buf[33] = '0' + ((int) (me->p_kills / 10));
  if (buf[33] == '0')
    buf[33] = ' ';
  buf[34] = '0' + (((int) me->p_kills) % 10);
  buf[35] = '.';
  buf[36] = '0' + (((int) (me->p_kills * 10)) % 10);
  buf[37] = '0' + (((int) (me->p_kills * 100)) % 10);
  buf[38] = ' ';
  buf[39] = ' ';
  buf[40] = ' ';
  buf[41] = ' ';
  buf[42] = '0' + ((me->p_armies % 100) / 10);
  if (buf[42] == '0')
    buf[42] = ' ';
  buf[43] = '0' + (me->p_armies % 10);
  buf[44] = ' ';
  buf[45] = ' ';

  buf[46] = '0' + (me->p_fuel / 100000);
  if (buf[46] == '0')
    buf[46] = ' ';
  buf[47] = '0' + ((me->p_fuel % 100000) / 10000);
  if ((buf[47] == '0') && (me->p_fuel < 100000))
    buf[47] = ' ';
  buf[48] = '0' + ((me->p_fuel % 10000) / 1000);
  if ((buf[48] == '0') && (me->p_fuel < 10000))
    buf[48] = ' ';
  buf[49] = '0' + ((me->p_fuel % 1000) / 100);
  if ((buf[49] == '0') && (me->p_fuel < 1000))
    buf[49] = ' ';
  buf[50] = '0' + ((me->p_fuel % 100) / 10);
  if ((buf[50] == '0') && (me->p_fuel < 100))
    buf[50] = ' ';
  buf[51] = '0' + (me->p_fuel % 10);
  buf[52] = ' ';
  buf[53] = ' ';
  buf[54] = ' ';

  buf[55] = '0' + ((me->p_wtemp / 10) / 100);
  if (buf[55] == '0')
    buf[55] = ' ';
  buf[56] = '0' + (((me->p_wtemp / 10) % 100) / 10);
  if ((buf[56] == '0') && (me->p_wtemp < 1000))
    buf[56] = ' ';
  buf[57] = '0' + ((me->p_wtemp / 10) % 10);

  buf[58] = ' ';
  buf[59] = ' ';
  buf[60] = ' ';

  buf[61] = '0' + ((me->p_etemp / 10) / 100);
  if (buf[61] == '0')
    buf[61] = ' ';
  buf[62] = '0' + (((me->p_etemp / 10) % 100) / 10);
  if ((buf[62] == '0') && (me->p_etemp < 1000))
    buf[62] = ' ';
  buf[63] = '0' + ((me->p_etemp / 10) % 10);

  if (whichbuf == 0)
    {
      /* Draw status line */
      W_WriteText (tstatw, 50, 16, textColor, buf, 64, W_RegularFont);
      whichbuf = 1;
    }
  else
    {				/* Hacks to make it print only what is necessary */
      whichbuf = 3 - whichbuf;
      j = -1;
      for (i = 0; i < 64; i++)
	{
	  if (*(buf++) != *(oldbuf++))
	    {
	      /* Different string */
	      if (j == -1)
		{
		  k = i;
		  s = buf - 1;
		}
	      j = 0;
	    }
	  else
	    {
	      /* Same string */
	      if (j == -1)
		continue;
	      j++;
	      if (j == 20)
		{		/* Random number */
		  W_WriteText (tstatw, 50 + W_Textwidth * k, 16, textColor,
			       s, i - k - 19, W_RegularFont);
		  j = -1;
		}
	    }
	}
      if (j != -1)
	{
	  W_WriteText (tstatw, 50 + W_Textwidth * k, 16, textColor, s, i - k - j,
		       W_RegularFont);
	}
    }
}

newcourse (x, y)
     int x, y;
{
  return ((unsigned char) (atan2 ((double) (x - me->p_x),
				  (double) (me->p_y - y)) / 3.14159 * 128.));
}

redrawTstats ()
{
  if (newDashboard)		/* 6/2/93 LAB */
    db_redraw (1);
  else
    {
      W_ClearWindow (tstatw);
      stline (1);		/* This is for refresh.  We redraw player stats too */
      updateMaxStats (1);	/* <isae> Seperated it */
    }
}

/* update stat window record for max speed, army capacity */
updateMaxStats (redraw)

     int redraw;
{
  char buf[BUFSIZ];
  static int lastdamage = -1;
  static int lastkills = -1;
  static int lastship = -1;
  int maxspeed;
  int troop_capacity;
  int mykills = (int) (10. * me->p_kills);

  if (newDashboard)
    return;
  /* don't really need a update if nothing's changed! */
  if (!redraw && lastkills == mykills && lastship == me->p_ship.s_type &&
      lastdamage == me->p_damage)
    return;

  lastkills = (int) (10. * me->p_kills);
  lastdamage = me->p_damage;
  lastship = me->p_ship.s_type;

  if (me->p_ship.s_type == ASSAULT)
    troop_capacity = (((me->p_kills * 3) > me->p_ship.s_maxarmies) ?
		      me->p_ship.s_maxarmies : (int) (me->p_kills * 3));
  else if (me->p_ship.s_type != STARBASE)
    troop_capacity = (((me->p_kills * 2) > me->p_ship.s_maxarmies) ?
		      me->p_ship.s_maxarmies : (int) (me->p_kills * 2));
  else
    troop_capacity = me->p_ship.s_maxarmies;

  maxspeed = (me->p_ship.s_maxspeed + 2) -
    (me->p_ship.s_maxspeed + 1) *
    ((float) me->p_damage / (float) (me->p_ship.s_maxdamage));
  if (maxspeed > me->p_ship.s_maxspeed)
    maxspeed = me->p_ship.s_maxspeed;
  if (maxspeed < 0)
    maxspeed = 0;


  sprintf (buf,
  "Flags        Warp Dam Shd Torps  Kills Armies   Fuel  Wtemp Etemp  Time");
  W_WriteText (tstatw, 50, 5, textColor, buf, strlen (buf), W_RegularFont);
  sprintf (buf,
	"Maximum:   %2d/%2d  %3d %3d              %2d/%2d  %6d   %3d   %3d",
	   maxspeed, me->p_ship.s_maxspeed,
	   me->p_ship.s_maxdamage, me->p_ship.s_maxshield,
	   troop_capacity, me->p_ship.s_maxarmies,
	   me->p_ship.s_maxfuel, me->p_ship.s_maxwpntemp / 10,
	   me->p_ship.s_maxegntemp / 10);
  W_WriteText (tstatw, 50, 27, textColor, buf, strlen (buf), W_RegularFont);
}
