/* 	$Id $	 */

#ifndef lint
static char vcid[] = "$Id $";
#endif /* lint */

#include <stdio.h>
#include <math.h>
#include "config.h"
#include "copyright.h"

#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

#include "bot.h"

typedef enum 
{
  GetBack,
  Guard,
  LockOntoPuck,
  ChasePuck,
  TurnTowardGoal,
  ShootAtGoal,
} MajorPlanType;

static MajorPlanType Plan = GetBack;
static int PUCK;
static struct player *Puck = 0;
static unsigned char CourseToPuck;
static int DistToPuck;
static int PlayerNearestPuck;

StartDefendStrategy()
/* Initializion code for the strategy */
{
  PUCK = GetPlayerByName("Puck");
  Puck = &(players[PUCK]);

  Plan = Guard;
}

StopDefendStrategy()
/* clear things out, if so desired */
{

}

DoDefendStrategy( void )
/* Run the ship */
{
  CourseToPuck = getglobalcourse(Puck->p_x, Puck->p_y);
  DistToPuck = (int) hypot((double) Puck->p_x - me->p_x,
			   (double) Puck->p_y - me->p_y);
  PlayerNearestPuck = PlayerNearestPlayer(PUCK);

  AutoShield();
  AutoTorp();
  AutoPhaser();
  
    if (Plan == GetBack) Plan = Guard;

    if (me->p_team == KLI) 
      {
	if (me->p_y > 35000)
	{
	    Plan = GetBack;
	}
      }
    else
      {
	if (me->p_y < 65000)
	{
	    Plan = GetBack;
	}
      }
      


  if (Plan == GetBack)
    {
      int spotX;
      int spotY;
      int up;
      int back;
      double h;
      unsigned char the_course;

      warning("Plan: GetBack");
    
      if (me->p_team == KLI) 
	{
	  up = GetPlanetByName("Klingus");
	  back = GetPlanetByName("Cygni");
	}
      else
	{
	  up = GetPlanetByName("Orion");
	  back = GetPlanetByName("Arcturus");
	}
      spotX = (planets[up].pl_x + planets[back].pl_x) / 2;
      spotY = (planets[up].pl_y + 2*planets[back].pl_y) / 3;

      the_course = getglobalcourse(spotX, spotY);
      set_course(the_course);
      
     if (angdist(me->p_dir, the_course) > 10)
	{
	  set_speed(3);
	}
      else
	{
	  h = hypot((double) (me->p_x - spotX), (double)(me->p_y - spotY));
	  if (h > 10000)
	    {
	      set_speed(me->p_ship.s_maxspeed);
	    }
	  else
	    {
	      int s = me->p_ship.s_maxspeed;
	      set_speed((s/4)*3 * h / 10000 + (s/4));
	    }
	  }
    }
    

  /*
   * Guard
   *
   * GWIDTH is width of galaxy
   * Guard the zone by staying 1/3 distance between the puck and
   *   front of goal scaled from puck_x/GWIDTH.  Say in front of the goal.
   *   If the puck goes behind, get to the post on the side the puck is on.
   *   until I am closest to the puck (then ATTACK).
   *   Always tractor puck, if possible.
   *   Keep speed low, when possible.
   *   When tractored puck, jump to REJECT
   */
  
  if (Plan == Guard)
    {
      int goalLeft;
      int goalWidth;
      int goalDepth;
      int goalY;
      int spotX;
      int spotY;
      int gSpotX, gSpotY;
      int left;
      int right;
      int back;
      double h;
      unsigned char the_course;

      char buffer[80];
      
      sprintf(buffer, "Plan: Guard  DistToPuck = %i", DistToPuck);
      
      warning(buffer);
      
      if (DistToPuck < 5 * TRACTDIST / 4)
	{
	  sendTractorReq(1, PUCK);
	  me->p_tractor = PUCK;
	}
      
      if (PlayerNearestPuck == me->p_no)
	{
	  Plan = LockOntoPuck;
	}
	
      if (me->p_team == KLI) 
	{
	  left = GetPlanetByName("Spica");
	  right = GetPlanetByName("Cassiopia");
	  back = GetPlanetByName("Cygni");
	}
      else
	{
	  left = GetPlanetByName("Scorpii");
	  right = GetPlanetByName("Lyrae");
	  back = GetPlanetByName("Arcturus");
	}

      goalLeft = planets[left].pl_x;
      goalWidth = planets[right].pl_x - planets[left].pl_x;
      goalDepth = ABS(planets[right].pl_y - planets[back].pl_y);
      goalY = planets[left].pl_y;
      
      gSpotX = goalLeft + (goalWidth * players[PUCK].p_x)/GWIDTH;
      gSpotY = GWIDTH - goalY;
      
      spotX = (3*gSpotX + 2*players[PUCK].p_x)/5;
      spotY = (3*gSpotY + 2*players[PUCK].p_y)/5;
      
      if (me->p_team == KLI) 
	{
	  if (spotY < 10000) spotY = 10000;
	}
      else
	{
	  if (spotY > 90000) spotY = 90000;
	}
      /* if (ABS(spotY - planets[back].pl_y) < goalDepth) spotY = gSpotY; */
      
	  
      the_course = getglobalcourse(spotX, spotY);
      set_course(the_course);
            
      if (angdist(me->p_dir, the_course) > 10)
	{
	  set_speed(3);
	}
      else
	{
	  h = hypot((double) (me->p_x - spotX), (double)(me->p_y - spotY));
	  if (h > (GWIDTH/16))
	    {
	      set_speed(me->p_ship.s_maxspeed);
	    }
	  else
	    {
	      int s = me->p_ship.s_maxspeed;
	      set_speed(s * (int) h / (GWIDTH/16));
	    }
	}
    }

  if (Plan == LockOntoPuck)
    {
      warning("Plan: LockOntoPuck");
/*    sendPlaylockReq(PUCK); */
      set_course(CourseToPuck);

      if (ABS(angdist(me->p_dir, CourseToPuck)) < 10)
	{
	  Plan = ChasePuck;
	}
      else set_speed(3);
      
    }
  if (Plan == ChasePuck)
    {
      int DistToPuck =
	(int) hypot( players[PUCK].p_x - me->p_x,
		    players[PUCK].p_y - me->p_y );
      
      warning("Plan: ChasePuck");
      set_speed(me->p_ship.s_maxspeed);
      set_course(CourseToPuck);
      
      if ((PlayerNearestPuck == me->p_no)
	  && (Puck->p_flags & PFSHIELD))
	{
	  Plan = TurnTowardGoal;
	} 
      else
	{
	  if (!(me->p_flags & PFTRACT)
	      && (DistToPuck < 3 * TRACTDIST / 2))
	    {
	      sendTractorReq(1, PUCK);
	      me->p_tractor = PUCK;
	    }
	  else
	    {
	      if (me->p_tractor != PUCK)
		{
		  sendTractorReq(0, me->p_no);
		}
	    }
	  
	  if (((angdist(me->p_dir, CourseToPuck) >= 10)
	       && !(me->p_flags & (PFTRACT)))
	      || ((angdist(me->p_dir, CourseToPuck) >= 10)
		  && (PlayerNearestPuck != me->p_no)
		  && (DistToPuck > TRACTDIST)))
/*	      || (DistToPuck > DistBetweenPlayers(me->p_no, PUCK) */
	    {
	      Plan = Guard;
	    }
	}
    }
  if (Plan == TurnTowardGoal)
    {
      warning("Plan: TurnTowardGoal");
      
      if (PlayerNearestPuck != me->p_no)
	{
	  Plan = Guard;
	}
      else
	{
	  int goalCenterX;
	  int goalCenterY;
	  int left;
	  int right;
	  unsigned char the_course;

	  if (me->p_team != KLI) 
	    {
	      left = GetPlanetByName("Spica");
	      right = GetPlanetByName("Cassiopia");
	    }
	  else
	    {
	      left = GetPlanetByName("Scorpii");
	      right = GetPlanetByName("Lyrae");
	    }

	  goalCenterX = (planets[left].pl_x + planets[right].pl_x) / 2;
	  goalCenterY = (planets[left].pl_y + planets[right].pl_y) / 2;

	  
	  the_course = (getglobalcourse(goalCenterX, goalCenterY) + 128) %256;
	  set_course(the_course);
	  
	  if (ABS(angdist(me->p_dir, the_course) > 10))
	    {
	      set_speed(0);
	    }
	     
	  
	  if (ABS(angdist(me->p_dir, the_course)) < 5)
	    {
	      Plan = ShootAtGoal;
	    }
	}
    }
  if (Plan == ShootAtGoal)
    {
      warning("Plan: ShootAtGoal");
      
      if (PlayerNearestPuck != me->p_no)
	{
	  Plan = Guard;
	}
      else
        {      
	  double dx, dy, h;
	 /* if (me->p_flags & (PFTRACT | PFPRESS))
	    {
	      sendTractorReq (0, me->p_no);
	    }*/
	  set_speed(me->p_ship.s_maxspeed);
	  if (((DistToPuck > 2000)
		 && (angdist(me->p_dir, CourseToPuck) >64))
		 || (me->p_speed < 8));
	    {
	      sendRepressReq(1, PUCK);
	      me->p_tractor = PUCK;
	      Plan = Guard;
	    }
	}
    }
}



void
DoDefendMessage( char *message, int len )
/* Handle messages */
{

    if (strstr(message, "<thunk!>"))
    {
      if (strncmp("Puck",message,4) == 0)
      Plan = Guard;
    }

  if (strstr(message, "END OF"))
    {
      if (strncmp("Puck",message,4) == 0)
      Plan = GetBack;
    }

  if (strstr(message, "Faceoff"))
    {
      if (strncmp("Puck",message,4) == 0)
      Plan = GetBack;
    }

  if (strstr(message, "scores for the"))
    {
      Plan = GetBack;
    }

    
  /* Call the generic message handler at end */
  DoGeneralMessage( message, len );
}
